/*
 * Copyright (C) MX4J.
 * All rights reserved.
 *
 * This software is distributed under the terms of the MX4J License version 1.0.
 * See the terms of the MX4J License in the documentation provided with this software.
 */

package javax.management;

/**
 *
 * @author <a href="mailto:biorn_steedom@users.sourceforge.net">Simone Bordet</a>
 * @version $Revision: 1.2 $
 */
class ClassAttributeValueExp extends AttributeValueExp
{
	private static final long serialVersionUID = -1081892073854801359L;

	// Never used, here only for serialization compatibility
	private String attr;
	private transient MBeanServer server;

	ClassAttributeValueExp() {}

	public void setMBeanServer(MBeanServer server)
	{
		super.setMBeanServer(server);
		this.server = server;
	}

	public ValueExp apply(ObjectName name) throws BadStringOperationException, BadBinaryOpValueExpException, BadAttributeValueExpException, InvalidApplicationException
	{
		try
		{
			String className = server.getObjectInstance(name).getClassName();
			return new StringValueExp(className);
		}
		catch (InstanceNotFoundException x)
		{
			return null;
		}
	}
}
