/*
 * Copyright (C) MX4J.
 * All rights reserved.
 *
 * This software is distributed under the terms of the MX4J License version 1.0.
 * See the terms of the MX4J License in the documentation provided with this software.
 */

package javax.management;

/**
 *
 * @author <a href="mailto:biorn_steedom@users.sourceforge.net">Simone Bordet</a>
 * @version $Revision: 1.3 $
 */
public class MBeanNotificationInfo extends MBeanFeatureInfo
{
	private static final long serialVersionUID = -3888371564530107064L;

	private String[] types;

    public MBeanNotificationInfo(String[] notifsType, String name, String description)
	{
		super(name, description);
		this.types = notifsType == null ? new String[0] : notifsType;
	}
	public String[] getNotifTypes()
	{
		return types;
	}

	public int hashCode()
	{
		int hash = super.hashCode();

		String[] notifs = getNotifTypes();
		for (int i = 0; i < notifs.length; ++i)
		{
			String notif = notifs[i];
			hash ^= notif == null ? 0 : notif.hashCode();
		}

		return hash;
	}

	public boolean equals(Object obj)
	{
		if (!super.equals(obj)) {return false;}

		try
		{
			MBeanNotificationInfo other = (MBeanNotificationInfo)obj;

			String[] notifs = getNotifTypes();
			String[] otherNotifs = other.getNotifTypes();
			if (notifs.length != otherNotifs.length) {return false;}
			for (int i = 0; i < notifs.length; ++i)
			{
				String notif = notifs[i];
				String otherNotif = otherNotifs[i];
				if (notif != null && !notif.equals(otherNotif)) {return false;}
				if (notif == null && otherNotif != null) {return false;}
			}
			return true;
		}
		catch (ClassCastException ignored) {}
		return false;
	}
}
