/*
 * Copyright (C) MX4J.
 * All rights reserved.
 *
 * This software is distributed under the terms of the MX4J License version 1.0.
 * See the terms of the MX4J License in the documentation provided with this software.
 */

package javax.management;

import java.security.BasicPermission;
import java.security.Permission;

/**
 *
 * @author <a href="mailto:biorn_steedom@users.sourceforge.net">Simone Bordet</a>
 * @version $Revision: 1.3 $
 */
public class MBeanServerPermission extends BasicPermission
{
	public MBeanServerPermission(String name)
	{
		this(name, null);
	}

	public MBeanServerPermission(String name, String actions)
	{
		super(name, actions);
        if (!"*".equals(name) &&
			!"newMBeanServer".equals(name) &&
			!"createMBeanServer".equals(name) &&
			!"findMBeanServer".equals(name) &&
			!"releaseMBeanServer".equals(name))
		{
			throw new RuntimeOperationsException(new IllegalArgumentException("Unknown MBeanServerPermission"));
		}
	}

	public boolean implies(Permission p)
	{
		boolean implies = super.implies(p);
		if (!implies)
		{
			if (getName().equals("createMBeanServer") && p.getName().equals("newMBeanServer"))
			{
				// createMBeanServer implies newMBeanServer
				return true;
			}
		}
		return implies;
	}
}
