/*
 * Copyright (C) MX4J.
 * All rights reserved.
 *
 * This software is distributed under the terms of the MX4J License version 1.0.
 * See the terms of the MX4J License in the documentation provided with this software.
 */

package javax.management.loading;

import java.util.Enumeration;
import java.util.Set;
import java.io.InputStream;
import java.io.IOException;
import java.net.URL;

import javax.management.ServiceNotFoundException;

/**
 *
 * @author <a href="mailto:biorn_steedom@users.sourceforge.net">Simone Bordet</a>
 * @version $Revision: 1.2 $
 */
public interface MLetMBean
{
	public void addURL(String url) throws ServiceNotFoundException;
	public void addURL(URL url);
	public URL[] getURLs();

	public String getLibraryDirectory();
	public void setLibraryDirectory(String libdir);

	public URL getResource(String name);
	public InputStream getResourceAsStream(String name);
	public Enumeration getResources(String name) throws IOException;

	public Set getMBeansFromURL(String url) throws ServiceNotFoundException;
	public Set getMBeansFromURL(URL url) throws ServiceNotFoundException;
}
