/*
 * Copyright (C) MX4J.
 * All rights reserved.
 *
 * This software is distributed under the terms of the MX4J License version 1.0.
 * See the terms of the MX4J License in the documentation provided with this software.
 */

package mx4j.adaptor.http;

/**
 * Contains utilities common to CommandProcessor objects
 *
 * @author <a href="mailto:tibu@users.sourceforge.net">Carlos Quiroz</a>
 * @version $Revision: 1.3 $
 */
public class CommandProcessorUtil
{
	/**
	 * Creates a parameter object of the given type containing a given value.
	 * If the type is unknown null is returned
	 *
	 * @param parameterType Indicates the type of the parameter, for instance java.lang.String
	 * @param parameterValue The value of the parameter as a String
	 * @return an object of parameterType type and value parameterValue or null if the type is unknown
	 * @exception Thrown in case there is a data conversion error
	 */
	protected static Object createParameterValue(String parameterType, String parameterValue) throws Exception {
		Object value = null;
		if (parameterType.equals("java.lang.String"))
		{
			value = parameterValue;
		}
		if (parameterType.equals("java.lang.Integer") || parameterType.equals("int"))
		{
			value = Integer.valueOf(parameterValue);
		}
		if (parameterType.equals("java.lang.Long") || parameterType.equals("long"))
		{
			value = Long.valueOf(parameterValue);
		}
		if (parameterType.equals("java.lang.Short") || parameterType.equals("short"))
		{
			value = Short.valueOf(parameterValue);
		}
		if (parameterType.equals("java.lang.Byte") || parameterType.equals("byte"))
		{
			value = Byte.valueOf(parameterValue);
		}
		if (parameterType.equals("java.lang.Float") || parameterType.equals("float"))
		{
			value = Float.valueOf(parameterValue);
		}
		// changed java.lang.dobule to java.lang.double bronwen
		if (parameterType.equals("java.lang.Double") || parameterType.equals("double"))
		{
				value = Double.valueOf(parameterValue);
		}
		if (parameterType.equals("java.lang.Boolean") || parameterType.equals("boolean"))
		{
				value = Boolean.valueOf(parameterValue);
		}
		return value;
	}
}
