/*
 * Copyright (C) MX4J.
 * All rights reserved.
 *
 * This software is distributed under the terms of the MX4J License version 1.0.
 * See the terms of the MX4J License in the documentation provided with this software.
 */

package mx4j.connector;

import java.io.PrintStream;
import java.io.PrintWriter;

import javax.management.JMRuntimeException;

/**
 *
 * @author <a href="mailto:biorn_steedom@users.sourceforge.net">Simone Bordet</a>
 * @version $Revision: 1.2 $
 */
public class ConnectorException extends JMRuntimeException
{
	private Exception m_exception;

	public ConnectorException() {}

	public ConnectorException(String s) {super(s);}

	public ConnectorException(Exception x) {m_exception = x;}

	public String getMessage()
	{
		String msg = "";
		String m1 = super.getMessage();
		if (m1 != null) {msg += m1;}
		if (m_exception != null)
		{
			String m2 = m_exception.toString();
			if (m2 != null) {msg += "nested exception is " + m2;}
		}
		return msg;
	}

    public Exception getTargetException() {return m_exception;}

	public void printStackTrace()
	{
		if (m_exception == null) {super.printStackTrace();}
		else
		{
			synchronized (System.err)
			{
				System.err.println(this);
				m_exception.printStackTrace();
			}
		}
	}

	public void printStackTrace(PrintStream s)
	{
		if (m_exception == null) {super.printStackTrace(s);}
		else
		{
			synchronized (s)
			{
				s.println(this);
				m_exception.printStackTrace(s);
			}
		}
	}

	public void printStackTrace(PrintWriter w)
	{
		if (m_exception == null) {super.printStackTrace(w);}
		else
		{
			synchronized (w)
			{
				w.println(this);
				m_exception.printStackTrace(w);
			}
		}
	}

}
