/*
 * Copyright (C) MX4J.
 * All rights reserved.
 *
 * This software is distributed under the terms of the MX4J License version 1.0.
 * See the terms of the MX4J License in the documentation provided with this software.
 */

package mx4j.server.interceptor;

/**
 * Management interface for the interceptor configurator
 *
 * @author <a href="mailto:biorn_steedom@users.sourceforge.net">Simone Bordet</a>
 * @version $Revision: 1.2 $
 */
public interface MBeanServerInterceptorConfiguratorMBean
{
	public static final String OBJECT_NAME = "JMImplementation:type=MBeanServerInterceptorConfigurator";

	/**
	 * Starts accepting calls in the interceptor chain
	 */
	public void start();
	/**
	 * Suspends the called in the interceptor chain until they're resumed with {@link #start}.
	 */
	public void stop();
	/**
	 * Returns whether the interceptor chain accept incoming calls or not.
	 */
	public boolean isRunning();
	/**
	 * TODO: add a management interface that is usable also via web interface
	 */
//	public void clearInterceptors();
}
